#ifndef EFL_TEXT_ANNOTATE_EO_HH
#define EFL_TEXT_ANNOTATE_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_text_annotate.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#ifndef EFL_TEXT_ANNOTATE_FWD_GUARD
#define EFL_TEXT_ANNOTATE_FWD_GUARD
namespace efl { 
struct Text_Annotate;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Text_Annotate> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Text_Annotate&> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Text_Annotate const> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Text_Annotate const&> : ::std::true_type {}; } }
#endif

#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wignored-qualifiers"


namespace eo_cxx {
namespace efl { 
struct Text_Annotate {
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits< ::efl::eina::string_view>::type annotation_get( ::efl::eolian::in_traits<Efl_Text_Annotate_Annotation const*>::type annotation) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<bool>::type annotation_set( ::efl::eolian::in_traits<Efl_Text_Annotate_Annotation const*>::type annotation,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type format) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<Efl_Text_Annotate_Annotation*>::type cursor_item_annotation_get( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits< ::efl::eina::iterator<Efl_Text_Annotate_Annotation const*>>::type range_annotations_get( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type start,  ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type end) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<Efl_Text_Annotate_Annotation*>::type annotation_insert( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type start,  ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type end,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type format) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<bool>::type annotation_del( ::efl::eolian::in_traits<Efl_Text_Annotate_Annotation const*>::type annotation) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type annotation_positions_get( ::efl::eolian::in_traits<Efl_Text_Annotate_Annotation const*>::type annotation,  ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type start,  ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type end) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<bool>::type annotation_is_item( ::efl::eolian::in_traits<Efl_Text_Annotate_Annotation const*>::type annotation) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<bool>::type item_geometry_get( ::efl::eolian::in_traits<Efl_Text_Annotate_Annotation const*>::type an,  ::efl::eolian::out_traits<int>::type x,  ::efl::eolian::out_traits<int>::type y,  ::efl::eolian::out_traits<int>::type w,  ::efl::eolian::out_traits<int>::type h) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<Efl_Text_Annotate_Annotation*>::type cursor_item_insert( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type item,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type format) const;
#endif
    static Efl_Class const* _eo_class()
    {
        return EFL_TEXT_ANNOTATE_INTERFACE;
    }
    Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Text_Annotate *>(this))); }
    operator ::efl::Text_Annotate() const;
    operator ::efl::Text_Annotate&();
    operator ::efl::Text_Annotate const&() const;
    /// @cond LOCAL
     ::efl::eolian::address_of_operator<Text_Annotate> operator&() { return {this}; }
     ::efl::eolian::address_of_operator<Text_Annotate const > operator&() const { return {this}; }
    /// @endcond
};
} 
}
namespace efl { 
struct Text_Annotate : private ::efl::eo::concrete
{
    explicit Text_Annotate( ::Eo* eo)
        : ::efl::eo::concrete(eo) {}
    Text_Annotate(std::nullptr_t)
        : ::efl::eo::concrete(nullptr) {}
    explicit Text_Annotate() = default;
    Text_Annotate(Text_Annotate const&) = default;
    Text_Annotate(Text_Annotate&&) = default;
    Text_Annotate& operator=(Text_Annotate const&) = default;
    Text_Annotate& operator=(Text_Annotate&&) = default;
    template <typename Derived>
    Text_Annotate(Derived&& derived
        , typename std::enable_if<
            ::efl::eo::is_eolian_object<Derived>::value
             && std::is_base_of< Text_Annotate, Derived>::value>::type* = 0)
            : ::efl::eo::concrete(derived._eo_ptr()) {}

#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits< ::efl::eina::string_view>::type annotation_get( ::efl::eolian::in_traits<Efl_Text_Annotate_Annotation const*>::type annotation) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<bool>::type annotation_set( ::efl::eolian::in_traits<Efl_Text_Annotate_Annotation const*>::type annotation,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type format) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<Efl_Text_Annotate_Annotation*>::type cursor_item_annotation_get( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits< ::efl::eina::iterator<Efl_Text_Annotate_Annotation const*>>::type range_annotations_get( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type start,  ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type end) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<Efl_Text_Annotate_Annotation*>::type annotation_insert( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type start,  ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type end,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type format) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<bool>::type annotation_del( ::efl::eolian::in_traits<Efl_Text_Annotate_Annotation const*>::type annotation) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type annotation_positions_get( ::efl::eolian::in_traits<Efl_Text_Annotate_Annotation const*>::type annotation,  ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type start,  ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type end) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<bool>::type annotation_is_item( ::efl::eolian::in_traits<Efl_Text_Annotate_Annotation const*>::type annotation) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<bool>::type item_geometry_get( ::efl::eolian::in_traits<Efl_Text_Annotate_Annotation const*>::type an,  ::efl::eolian::out_traits<int>::type x,  ::efl::eolian::out_traits<int>::type y,  ::efl::eolian::out_traits<int>::type w,  ::efl::eolian::out_traits<int>::type h) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<Efl_Text_Annotate_Annotation*>::type cursor_item_insert( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type item,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type format) const;
#endif
    static Efl_Class const* _eo_class()
    {
        return EFL_TEXT_ANNOTATE_INTERFACE;
    }
    Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Text_Annotate *>(this))); }
    /// @cond LOCAL
     ::efl::eolian::address_of_operator<Text_Annotate> operator&() { return {this}; }
     ::efl::eolian::address_of_operator<Text_Annotate const > operator&() const { return {this}; }
    /// @endcond
    ::efl::eo::wref<Text_Annotate> _get_wref() const { return ::efl::eo::wref<Text_Annotate>(*this); }
    ::efl::eo::concrete const& _get_concrete() const { return *this; }
    ::efl::eo::concrete& _get_concrete() { return *this; }
    using ::efl::eo::concrete::_eo_ptr;
    using ::efl::eo::concrete::_release;
    using ::efl::eo::concrete::_reset;
    using ::efl::eo::concrete::_delete;
    using ::efl::eo::concrete::operator bool;
#ifdef EFL_CXXPERIMENTAL
    const Text_Annotate* operator->() const { return this; }
    Text_Annotate* operator->() { return this; }
    operator Eo*() const { return _eo_ptr(); }
#endif 
    friend bool operator==(Text_Annotate const& lhs, Text_Annotate const& rhs)
    { return lhs._get_concrete() == rhs._get_concrete(); }
    friend bool operator!=(Text_Annotate const& lhs, Text_Annotate const& rhs)
    { return !(lhs == rhs); }
};
static_assert(sizeof(Text_Annotate) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Text_Annotate>::value, "");
} 

#pragma GCC diagnostic pop

#endif
