#ifndef EFL_TEXT_CURSOR_EO_HH
#define EFL_TEXT_CURSOR_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_text_cursor.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#ifndef EFL_TEXT_CURSOR_FWD_GUARD
#define EFL_TEXT_CURSOR_FWD_GUARD
namespace efl { 
struct Text_Cursor;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Text_Cursor> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Text_Cursor&> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Text_Cursor const> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Text_Cursor const&> : ::std::true_type {}; } }
#endif

#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wignored-qualifiers"


namespace eo_cxx {
namespace efl { 
struct Text_Cursor {
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<Efl_Text_Cursor_Cursor*>::type text_cursor_get( ::efl::eolian::in_traits<Efl_Text_Cursor_Get_Type>::type get_type) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<int>::type cursor_position_get( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_position_set( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur,  ::efl::eolian::in_traits<int>::type position) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<Eina_Unicode>::type cursor_content_get( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<bool>::type cursor_geometry_get( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur,  ::efl::eolian::in_traits<Efl_Text_Cursor_Type>::type ctype,  ::efl::eolian::out_traits<int>::type cx,  ::efl::eolian::out_traits<int>::type cy,  ::efl::eolian::out_traits<int>::type cw,  ::efl::eolian::out_traits<int>::type ch,  ::efl::eolian::out_traits<int>::type cx2,  ::efl::eolian::out_traits<int>::type cy2,  ::efl::eolian::out_traits<int>::type cw2,  ::efl::eolian::out_traits<int>::type ch2) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<Efl_Text_Cursor_Cursor*>::type cursor_new() const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_free( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<bool>::type cursor_equal( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur1,  ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur2) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<int>::type cursor_compare( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur1,  ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur2) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_copy( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type dst,  ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type src) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_char_next( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_char_prev( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_cluster_next( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_cluster_prev( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_paragraph_char_first( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_paragraph_char_last( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_word_start( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_word_end( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_line_char_first( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_line_char_last( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_paragraph_first( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_paragraph_last( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_paragraph_next( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_paragraph_prev( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_line_jump_by( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur,  ::efl::eolian::in_traits<int>::type by) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_coord_set( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur,  ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_cluster_coord_set( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur,  ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<int>::type cursor_text_insert( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type text) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_char_delete( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
    static Efl_Class const* _eo_class()
    {
        return EFL_TEXT_CURSOR_INTERFACE;
    }
    Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Text_Cursor *>(this))); }
    operator ::efl::Text_Cursor() const;
    operator ::efl::Text_Cursor&();
    operator ::efl::Text_Cursor const&() const;
    /// @cond LOCAL
     ::efl::eolian::address_of_operator<Text_Cursor> operator&() { return {this}; }
     ::efl::eolian::address_of_operator<Text_Cursor const > operator&() const { return {this}; }
    /// @endcond
};
} 
}
namespace efl { 
struct Text_Cursor : private ::efl::eo::concrete
{
    explicit Text_Cursor( ::Eo* eo)
        : ::efl::eo::concrete(eo) {}
    Text_Cursor(std::nullptr_t)
        : ::efl::eo::concrete(nullptr) {}
    explicit Text_Cursor() = default;
    Text_Cursor(Text_Cursor const&) = default;
    Text_Cursor(Text_Cursor&&) = default;
    Text_Cursor& operator=(Text_Cursor const&) = default;
    Text_Cursor& operator=(Text_Cursor&&) = default;
    template <typename Derived>
    Text_Cursor(Derived&& derived
        , typename std::enable_if<
            ::efl::eo::is_eolian_object<Derived>::value
             && std::is_base_of< Text_Cursor, Derived>::value>::type* = 0)
            : ::efl::eo::concrete(derived._eo_ptr()) {}

#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<Efl_Text_Cursor_Cursor*>::type text_cursor_get( ::efl::eolian::in_traits<Efl_Text_Cursor_Get_Type>::type get_type) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<int>::type cursor_position_get( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_position_set( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur,  ::efl::eolian::in_traits<int>::type position) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<Eina_Unicode>::type cursor_content_get( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<bool>::type cursor_geometry_get( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur,  ::efl::eolian::in_traits<Efl_Text_Cursor_Type>::type ctype,  ::efl::eolian::out_traits<int>::type cx,  ::efl::eolian::out_traits<int>::type cy,  ::efl::eolian::out_traits<int>::type cw,  ::efl::eolian::out_traits<int>::type ch,  ::efl::eolian::out_traits<int>::type cx2,  ::efl::eolian::out_traits<int>::type cy2,  ::efl::eolian::out_traits<int>::type cw2,  ::efl::eolian::out_traits<int>::type ch2) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<Efl_Text_Cursor_Cursor*>::type cursor_new() const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_free( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<bool>::type cursor_equal( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur1,  ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur2) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<int>::type cursor_compare( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur1,  ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur2) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_copy( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type dst,  ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type src) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_char_next( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_char_prev( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_cluster_next( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_cluster_prev( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_paragraph_char_first( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_paragraph_char_last( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_word_start( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_word_end( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_line_char_first( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_line_char_last( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_paragraph_first( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_paragraph_last( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_paragraph_next( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_paragraph_prev( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_line_jump_by( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur,  ::efl::eolian::in_traits<int>::type by) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_coord_set( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur,  ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_cluster_coord_set( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur,  ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<int>::type cursor_text_insert( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type text) const;
#endif
#ifdef EFL_BETA_API_SUPPORT
    ::efl::eolian::return_traits<void>::type cursor_char_delete( ::efl::eolian::in_traits<Efl_Text_Cursor_Cursor const*>::type cur) const;
#endif
    static Efl_Class const* _eo_class()
    {
        return EFL_TEXT_CURSOR_INTERFACE;
    }
    Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Text_Cursor *>(this))); }
    /// @cond LOCAL
     ::efl::eolian::address_of_operator<Text_Cursor> operator&() { return {this}; }
     ::efl::eolian::address_of_operator<Text_Cursor const > operator&() const { return {this}; }
    /// @endcond
    ::efl::eo::wref<Text_Cursor> _get_wref() const { return ::efl::eo::wref<Text_Cursor>(*this); }
    ::efl::eo::concrete const& _get_concrete() const { return *this; }
    ::efl::eo::concrete& _get_concrete() { return *this; }
    using ::efl::eo::concrete::_eo_ptr;
    using ::efl::eo::concrete::_release;
    using ::efl::eo::concrete::_reset;
    using ::efl::eo::concrete::_delete;
    using ::efl::eo::concrete::operator bool;
#ifdef EFL_CXXPERIMENTAL
    const Text_Cursor* operator->() const { return this; }
    Text_Cursor* operator->() { return this; }
    operator Eo*() const { return _eo_ptr(); }
#endif 
    friend bool operator==(Text_Cursor const& lhs, Text_Cursor const& rhs)
    { return lhs._get_concrete() == rhs._get_concrete(); }
    friend bool operator!=(Text_Cursor const& lhs, Text_Cursor const& rhs)
    { return !(lhs == rhs); }
};
static_assert(sizeof(Text_Cursor) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Text_Cursor>::value, "");
} 

#pragma GCC diagnostic pop

#endif
